"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const fast_xml_parser_1 = require("fast-xml-parser");
function XMLLoader() {
    return {
        name: 'xml-loader',
        transform(_, id) {
            return __awaiter(this, void 0, void 0, function* () {
                const xmlRegEx = /\.xml$/;
                if (xmlRegEx.test(id)) {
                    const xml = (0, fs_1.readFileSync)(id).toString();
                    const parser = new fast_xml_parser_1.XMLParser();
                    const convertedObj = yield parser.parse(xml);
                    const buf = Buffer.from(JSON.stringify(convertedObj));
                    return {
                        code: `export default ${buf}`,
                    };
                }
                return {};
            });
        },
    };
}
exports.default = XMLLoader;
